VERSION 5.00
Begin VB.Form frmUUID 
   AutoRedraw      =   -1  'True
   Caption         =   "Make A UUID"
   ClientHeight    =   2055
   ClientLeft      =   2625
   ClientTop       =   1500
   ClientWidth     =   4965
   LinkTopic       =   "Form1"
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   137
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   331
   Begin VB.TextBox Text1 
      Height          =   270
      Left            =   600
      TabIndex        =   1
      Top             =   525
      Width           =   3720
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Make A UUID/GUID"
      Height          =   345
      Left            =   1095
      TabIndex        =   0
      Top             =   1155
      Width           =   2670
   End
End
Attribute VB_Name = "frmUUID"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
  Option Explicit
  ' demo project showing how to create a UUID (GUID) and convert it
  ' to a string using the UuidCreate and UuidToString API functions.
  ' by Bryan Stafford of New Vision Software - newvision@imt.net
  ' this demo is released into the public domain "as is" without
  ' warranty or guaranty of any kind.  In other words, use at
  ' your own risk.
  
  
  Private Const RPC_S_OK As Long = 0&
  Private Const RPC_S_UUID_LOCAL_ONLY As Long = 1824&
  Private Const RPC_S_UUID_NO_ADDRESS As Long = 1739&
  
  Private Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(7) As Byte
  End Type
  
  Private Declare Function UuidCreate& Lib "rpcrt4" (lpGUID As GUID)
  Private Declare Function UuidToString& Lib "rpcrt4" Alias "UuidToStringA" (lpGUID As GUID, lpGUIDString&)
  Private Declare Function RpcStringFree& Lib "rpcrt4" Alias "RpcStringFreeA" (lpGUIDString&)
  
  Private Declare Function lstrlen& Lib "kernel32" Alias "lstrlenA" (ByVal lpString&)

  Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (lpDest As Any, lpSource As Any, ByVal cBytes&)

Private Sub Command1_Click()
  
  Text1.Text = CreateGUID()
  
End Sub

Public Function CreateGUID() As String

  Dim nGUID As GUID, lpStrGUID&, nStrLen&, sGUID$
  Dim sBuffer() As Byte, bNoError As Boolean
  
  ' create the GUID
  If UuidCreate(nGUID) <> RPC_S_UUID_NO_ADDRESS Then

    ' if the GUID was created, convert it to a string since we
    ' can't do much with the struct that holds it now
    If UuidToString(nGUID, lpStrGUID) = RPC_S_OK Then
    
      ' get the length of the string that was returned
      nStrLen = lstrlen(lpStrGUID)
  
      ' dimention our byte array to the proper size
      ReDim sBuffer(nStrLen - 1) As Byte
      
      ' copy the string to the byte array
      CopyMemory sBuffer(0), ByVal lpStrGUID, nStrLen
    
      ' release the memory for the string that Windows returned
      Call RpcStringFree(lpStrGUID)
  
      ' convert the string to unicode so that we can display it.
      ' if you don't need to display the string, you may want to
      ' remove this call since converting to unicode doubles the
      ' amount of the storage space required.
      sGUID = StrConv(sBuffer, vbUnicode)

      ' show it in the label
      CreateGUID = UCase$(sGUID)
      
      ' exit before the error message
      Exit Function
    End If
  End If
  
  ' if we get here an error occurred
  CreateGUID = "Error, unable to create GUID"
  
End Function
